package ants.controller;

import ants.model.Board;
import ants.gui.AntGUI;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Controller {
  
    protected Board board;
    protected AntGUI gui;
        
    protected final int NUM_THREADS = 4;
    
    public Controller(Board board, AntGUI gui) {
        this.board = board;
        this.gui = gui;
        generateAnts();
        
        guiThread();
        threadsStart();
        
    }  
    
    private void generateAnts(){
        for (int i = 0; i < board.getWidth(); i++){
            for (int j = 0; j < board.getHeight(); j++){
                if (Math.random()<0.1){
                    board.setValue(i, j, 1);
                }
            }
        }
    
    }

    private void guiThread() {
        new Thread(() -> {
            long time = System.currentTimeMillis();
            while(true){
                try {
                    gui.repaint();
                    Thread.sleep(50);
                    gui.setLabelText("" + (System.currentTimeMillis() - time));
                int number = 0;
                
                    board.setStop(true);
                    Thread.sleep(10);
                    for (int i = 0; i < board.getHeight(); i++) {
                        for (int j = 0; j < board.getWidth(); j++) {
                            if (board.getValue(j, i)==1) {
                                number++;
                            }
                        }
                    }
                    board.setStop(false);
                    gui.setLabel2Text(""+number);
                
                
                
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
            }       
        }).start();
    }

    private void threadsStart() {
        for (int i = 0; i < NUM_THREADS; i++) {
            Controlthread t = new Controlthread();
            t.start();
        }        
    }
    
    private void randomSleep(){
        try {
            Thread.sleep((long) (Math.random()*10));
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
    }
    
    private class Controlthread extends Thread {

        @Override
        public void run() {
            while(true){
                int x;
                int y;
                do{
                    x = (int) (Math.random()*board.getWidth());
                    y = (int) (Math.random()*board.getHeight());                          
                }while(!board.popAnt(x, y));

  //              board.setValue(x, y, 0);
                
                do{
                    x = (int) (Math.random()*board.getWidth());
                    y = (int) (Math.random()*board.getHeight());                          
                }while(!board.pushAnt(x, y));
                
//                board.setValue(x, y, 1);
            }
        }
    }
    
}
    
    
    

